local M = {}

local helper = require('scenario/scenariohelper')
local playerInstance = 'scenario_player0'
local trailerInstance = 'trailer'

local function fail(reason)
  scenario_scenarios.finish({failed = reason})
end

local function success(reason)
  scenario_scenarios.finish({msg = reason})
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'trailer_goal' then
			if data.subjectName == trailerInstance then
				success('you brought all the equipment! congratulations!')						
			end
	end
	
end

local function onRaceWaypointReached(data)
	local playerVehicleId = be:getPlayerVehicleID(0)
	if data.vehicleId == playerVehicleId then

		if data.waypointName == 'wp1' then
			ui_message('Turn right, the trailer is prepared and parked by the toilets')	
		end
		if data.waypointName == 'wp2' then
			ui_message('Connect the trailer using [L]. Careful- do not drop anything!')
		end
		if data.waypointName == 'wp13' then
			ui_message('Please park the trailer nicely right between the caravan and those metal bars!')
		end
	end
end

local function onRaceTick(raceTickTime)
    local trailerData = map.objects[map.objectNames['trailer']]
    local woodData = map.objects[map.objectNames['wood']]
    local barrel1Data = map.objects[map.objectNames['barrel1']]
    local barrel2Data = map.objects[map.objectNames['barrel2']]
    local distanceB1ToTrailer = math.abs((trailerData.pos - barrel1Data.pos):length())
    local distanceB2ToTrailer = math.abs((trailerData.pos - barrel2Data.pos):length())
    local distanceWToTrailer = math.abs((trailerData.pos - woodData.pos):length())
    if distanceB1ToTrailer > 10 or distanceB2ToTrailer > 10 then
        fail('You lost the barrel!')
    end
	if distanceWToTrailer > 10 then
        fail('You lost the wood planks!')
    end
end

M.onRaceWaypointReached = onRaceWaypointReached
M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceTick = onRaceTick


return M



